# How to install Toxygen

### Linux

1. Install [c-toxcore](https://github.com/TokTok/c-toxcore/)
2. Install PortAudio: 
``sudo apt-get install portaudio19-dev``
3. For 32-bit Linux install PyQt5: ``sudo apt-get install python3-pyqt5``
4. Install [OpenCV](http://docs.opencv.org/trunk/d7/d9f/tutorial_linux_install.html) or via ``sudo pip3 install opencv-python``
5. Install [toxygen](https://git.plastiras.org/emdee/toxygen/)
6. Run toxygen using ``toxygen`` command.

## From source code (recommended for developers)

### Windows

Note: 32-bit Python isn't supported due to bug with videocalls. It is strictly recommended to use 64-bit Python.

1. [Download and install latest Python 3 64-bit](https://www.python.org/downloads/windows/)
2. Install PyQt5: ``pip install pyqt5``
3. Install PyAudio: ``pip install pyaudio``
4. Install numpy: ``pip install numpy``
5. Install OpenCV: ``pip install opencv-python``
6. git clone --depth=1 https://git.plastiras.org/emdee/toxygen/
7. I don't know
8. Download latest libtox.dll build, download latest libsodium.a build, put it into \toxygen\libs\
9. Run \toxygen\main.py.

### Linux

1. Install latest Python3: 
``sudo apt-get install python3``
2. Install PyQt5: ``sudo apt-get install python3-pyqt5``
3. Install [toxcore](https://github.com/TokTok/c-toxcore) with toxav support)
4. Install PyAudio: ``sudo apt-get install portaudio19-dev python3-pyaudio`` (or ``sudo pip3 install pyaudio``)
5. Install toxygen_wrapper https://git.plastiras.org/emdee/toxygen_wrapper
6. Install the rest of the requirements: ``sudo pip3 install -m requirements.txt``
7. git clone --depth=1 [toxygen](https://git.plastiras.org/emdee/toxygen/)
8. Look in the Makefile for the install target and type
``
make install
``
You should set the PIP_EXE_MSYS and PYTHON_EXE_MSYS variables and it does
``
	${PIP_EXE_MSYS} --python ${PYTHON_EXE_MSYS} install \
		--target ${PREFIX}/lib/python${PYTHON_MINOR}/site-packages/ \
		--upgrade .
``
9. Run app:
``python3 ${PREFIX}/lib/python${PYTHON_MINOR}/site-packages/bin/toxygen``

