import sys
import os
from setuptools import setup
from setuptools.command.install import install

version = '1.0.0'

MODULES = open('requirements.txt', 'rt').readlines()

def get_packages():
    directory = os.path.join(os.path.dirname(__file__), 'tox_wrapper')
    for root, dirs, files in os.walk(directory):
        packages = map(lambda d: 'toxygen.' + d, dirs)
        packages = ['toxygen'] + list(packages)
        return packages

class InstallScript(install):
    """This class configures Toxygen after installation"""

    def run(self):
        install.run(self)

setup(name='Toxygen',
      version=version,
      description='Toxygen - Tox client',
      long_description='Toxygen is powerful Tox client written in Python3',
      url='https://git.plastiras.org/emdee/toxygen/',
      keywords='toxygen Tox messenger',
      author='Ingvar',
      maintainer='',
      license='GPL3',
      packages=get_packages(),
      install_requires=MODULES,
      include_package_data=True,
      classifiers=[
          'Programming Language :: Python :: 3 :: Only',
    "Programming Language :: Python :: 3.6",
    "Programming Language :: Python :: 3.7",
    "Programming Language :: Python :: 3.8",
    "Programming Language :: Python :: 3.9",
    "Programming Language :: Python :: 3.10",
    "Programming Language :: Python :: 3.11",
          'Programming Language :: Python :: 3.11',
      ],
      entry_points={
          'console_scripts': ['toxygen=toxygen.main:main']
      },
      package_data={"": ["*.ui"],},
      cmdclass={
          'install': InstallScript,
      },
      zip_safe=False
      )
